﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace XamGridObservableDictionary
{
    public partial class MainPage : UserControl
    {
        public ObservableDictionary<int, MyObject> data { get; set; }

        public MainPage()
        {
            InitializeComponent();
            data = new ObservableDictionary<int, MyObject>(); Random r = new Random();

            for (int i = 1; i < 10000; i++)
                data.Add(i, new MyObject(i) { Name = string.Format("Person {0:d4}", i), Age = r.Next() % 100 });

            this.DataContext = data;
        }

        private void Add_Click(object sender, RoutedEventArgs e)
        {
            int index = data.Count + 1; Random r = new Random();

            data.Add(index, new MyObject(index) { Name = string.Format("Person {0:d4}", index), Age = r.Next() % 100 });
        }

        private void Remove_Click(object sender, RoutedEventArgs e)
        {
            data.Remove(data.LastOrDefault().Key);
        }

        private void Update_Click(object sender, RoutedEventArgs e)
        {
            foreach (var kvp in data)
            {
                kvp.Value.Age++;
            }
        }
    }

    public class MyObject : INotifyPropertyChanged
    {
        public MyObject(int objid)
        {
            _ObjectID = objid;
        }

        private int _ObjectID;
        public int ObjectID
        {
            get
            {
                return _ObjectID;
            }
        }

        private int _Age;
        public int Age
        {
            get
            {
                return _Age;
            }

            set
            {
                _Age = value;

                this.OnPropertyChanged("Age");
            }
        }

        private string _Name;
        public string Name
        {
            get
            {
                return _Name;
            }

            set
            {
                _Name = value;

                this.OnPropertyChanged("Name");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propname)
        {
            if ((this.PropertyChanged != null))
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(propname));
            }
        }
    }
}
